/**
 * <copyright>
 * </copyright>
 *
 */
package org.openxma.dsl.ddl.ddlDsl.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.openxma.dsl.ddl.ddlDsl.AddTableConstraint;
import org.openxma.dsl.ddl.ddlDsl.Alter;
import org.openxma.dsl.ddl.ddlDsl.AlterTableAction;
import org.openxma.dsl.ddl.ddlDsl.Column;
import org.openxma.dsl.ddl.ddlDsl.ColumnComment;
import org.openxma.dsl.ddl.ddlDsl.Comment;
import org.openxma.dsl.ddl.ddlDsl.Constraint;
import org.openxma.dsl.ddl.ddlDsl.Create;
import org.openxma.dsl.ddl.ddlDsl.CreateIndex;
import org.openxma.dsl.ddl.ddlDsl.CreateTable;
import org.openxma.dsl.ddl.ddlDsl.Ddl;
import org.openxma.dsl.ddl.ddlDsl.DdlDslFactory;
import org.openxma.dsl.ddl.ddlDsl.DdlDslPackage;
import org.openxma.dsl.ddl.ddlDsl.DdlStatement;
import org.openxma.dsl.ddl.ddlDsl.Drop;
import org.openxma.dsl.ddl.ddlDsl.DropTableConstraint;
import org.openxma.dsl.ddl.ddlDsl.ForeignKeyConstraint;
import org.openxma.dsl.ddl.ddlDsl.LargeObjectType;
import org.openxma.dsl.ddl.ddlDsl.LongRaw;
import org.openxma.dsl.ddl.ddlDsl.NullableConstraint;
import org.openxma.dsl.ddl.ddlDsl.PrimaryKeyConstraint;
import org.openxma.dsl.ddl.ddlDsl.Raw;
import org.openxma.dsl.ddl.ddlDsl.ReferenceClause;
import org.openxma.dsl.ddl.ddlDsl.RowIdType;
import org.openxma.dsl.ddl.ddlDsl.SortDirectionEnum;
import org.openxma.dsl.ddl.ddlDsl.SqlBoolean;
import org.openxma.dsl.ddl.ddlDsl.SqlCharacter;
import org.openxma.dsl.ddl.ddlDsl.SqlDataType;
import org.openxma.dsl.ddl.ddlDsl.SqlDate;
import org.openxma.dsl.ddl.ddlDsl.SqlDateTime;
import org.openxma.dsl.ddl.ddlDsl.SqlInterval;
import org.openxma.dsl.ddl.ddlDsl.SqlNumber;
import org.openxma.dsl.ddl.ddlDsl.SqlTimeStamp;
import org.openxma.dsl.ddl.ddlDsl.TableComment;
import org.openxma.dsl.ddl.ddlDsl.TableProperty;
import org.openxma.dsl.ddl.ddlDsl.UniqueKeyConstraint;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DdlDslFactoryImpl extends EFactoryImpl implements DdlDslFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static DdlDslFactory init()
  {
    try
    {
      DdlDslFactory theDdlDslFactory = (DdlDslFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.openxma.org/dsl/ddl/DdlDsl"); 
      if (theDdlDslFactory != null)
      {
        return theDdlDslFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new DdlDslFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DdlDslFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case DdlDslPackage.DDL: return createDdl();
      case DdlDslPackage.DDL_STATEMENT: return createDdlStatement();
      case DdlDslPackage.ALTER: return createAlter();
      case DdlDslPackage.ALTER_TABLE_ACTION: return createAlterTableAction();
      case DdlDslPackage.DROP_TABLE_CONSTRAINT: return createDropTableConstraint();
      case DdlDslPackage.COMMENT: return createComment();
      case DdlDslPackage.TABLE_COMMENT: return createTableComment();
      case DdlDslPackage.COLUMN_COMMENT: return createColumnComment();
      case DdlDslPackage.ADD_TABLE_CONSTRAINT: return createAddTableConstraint();
      case DdlDslPackage.CREATE: return createCreate();
      case DdlDslPackage.CREATE_TABLE: return createCreateTable();
      case DdlDslPackage.CREATE_INDEX: return createCreateIndex();
      case DdlDslPackage.TABLE_PROPERTY: return createTableProperty();
      case DdlDslPackage.COLUMN: return createColumn();
      case DdlDslPackage.DROP: return createDrop();
      case DdlDslPackage.CONSTRAINT: return createConstraint();
      case DdlDslPackage.NULLABLE_CONSTRAINT: return createNullableConstraint();
      case DdlDslPackage.UNIQUE_KEY_CONSTRAINT: return createUniqueKeyConstraint();
      case DdlDslPackage.PRIMARY_KEY_CONSTRAINT: return createPrimaryKeyConstraint();
      case DdlDslPackage.FOREIGN_KEY_CONSTRAINT: return createForeignKeyConstraint();
      case DdlDslPackage.REFERENCE_CLAUSE: return createReferenceClause();
      case DdlDslPackage.SQL_DATA_TYPE: return createSqlDataType();
      case DdlDslPackage.SQL_BOOLEAN: return createSqlBoolean();
      case DdlDslPackage.SQL_CHARACTER: return createSqlCharacter();
      case DdlDslPackage.SQL_NUMBER: return createSqlNumber();
      case DdlDslPackage.LONG_RAW: return createLongRaw();
      case DdlDslPackage.LONG: return createLong();
      case DdlDslPackage.RAW: return createRaw();
      case DdlDslPackage.SQL_DATE_TIME: return createSqlDateTime();
      case DdlDslPackage.SQL_DATE: return createSqlDate();
      case DdlDslPackage.SQL_TIME_STAMP: return createSqlTimeStamp();
      case DdlDslPackage.SQL_INTERVAL: return createSqlInterval();
      case DdlDslPackage.LARGE_OBJECT_TYPE: return createLargeObjectType();
      case DdlDslPackage.ROW_ID_TYPE: return createRowIdType();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case DdlDslPackage.SORT_DIRECTION_ENUM:
        return createSortDirectionEnumFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case DdlDslPackage.SORT_DIRECTION_ENUM:
        return convertSortDirectionEnumToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Ddl createDdl()
  {
    DdlImpl ddl = new DdlImpl();
    return ddl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DdlStatement createDdlStatement()
  {
    DdlStatementImpl ddlStatement = new DdlStatementImpl();
    return ddlStatement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Alter createAlter()
  {
    AlterImpl alter = new AlterImpl();
    return alter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AlterTableAction createAlterTableAction()
  {
    AlterTableActionImpl alterTableAction = new AlterTableActionImpl();
    return alterTableAction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DropTableConstraint createDropTableConstraint()
  {
    DropTableConstraintImpl dropTableConstraint = new DropTableConstraintImpl();
    return dropTableConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Comment createComment()
  {
    CommentImpl comment = new CommentImpl();
    return comment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TableComment createTableComment()
  {
    TableCommentImpl tableComment = new TableCommentImpl();
    return tableComment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ColumnComment createColumnComment()
  {
    ColumnCommentImpl columnComment = new ColumnCommentImpl();
    return columnComment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AddTableConstraint createAddTableConstraint()
  {
    AddTableConstraintImpl addTableConstraint = new AddTableConstraintImpl();
    return addTableConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Create createCreate()
  {
    CreateImpl create = new CreateImpl();
    return create;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CreateTable createCreateTable()
  {
    CreateTableImpl createTable = new CreateTableImpl();
    return createTable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CreateIndex createCreateIndex()
  {
    CreateIndexImpl createIndex = new CreateIndexImpl();
    return createIndex;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TableProperty createTableProperty()
  {
    TablePropertyImpl tableProperty = new TablePropertyImpl();
    return tableProperty;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Column createColumn()
  {
    ColumnImpl column = new ColumnImpl();
    return column;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Drop createDrop()
  {
    DropImpl drop = new DropImpl();
    return drop;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Constraint createConstraint()
  {
    ConstraintImpl constraint = new ConstraintImpl();
    return constraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NullableConstraint createNullableConstraint()
  {
    NullableConstraintImpl nullableConstraint = new NullableConstraintImpl();
    return nullableConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UniqueKeyConstraint createUniqueKeyConstraint()
  {
    UniqueKeyConstraintImpl uniqueKeyConstraint = new UniqueKeyConstraintImpl();
    return uniqueKeyConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PrimaryKeyConstraint createPrimaryKeyConstraint()
  {
    PrimaryKeyConstraintImpl primaryKeyConstraint = new PrimaryKeyConstraintImpl();
    return primaryKeyConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ForeignKeyConstraint createForeignKeyConstraint()
  {
    ForeignKeyConstraintImpl foreignKeyConstraint = new ForeignKeyConstraintImpl();
    return foreignKeyConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReferenceClause createReferenceClause()
  {
    ReferenceClauseImpl referenceClause = new ReferenceClauseImpl();
    return referenceClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlDataType createSqlDataType()
  {
    SqlDataTypeImpl sqlDataType = new SqlDataTypeImpl();
    return sqlDataType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlBoolean createSqlBoolean()
  {
    SqlBooleanImpl sqlBoolean = new SqlBooleanImpl();
    return sqlBoolean;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlCharacter createSqlCharacter()
  {
    SqlCharacterImpl sqlCharacter = new SqlCharacterImpl();
    return sqlCharacter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlNumber createSqlNumber()
  {
    SqlNumberImpl sqlNumber = new SqlNumberImpl();
    return sqlNumber;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public LongRaw createLongRaw()
  {
    LongRawImpl longRaw = new LongRawImpl();
    return longRaw;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public org.openxma.dsl.ddl.ddlDsl.Long createLong()
  {
    LongImpl long_ = new LongImpl();
    return long_;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Raw createRaw()
  {
    RawImpl raw = new RawImpl();
    return raw;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlDateTime createSqlDateTime()
  {
    SqlDateTimeImpl sqlDateTime = new SqlDateTimeImpl();
    return sqlDateTime;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlDate createSqlDate()
  {
    SqlDateImpl sqlDate = new SqlDateImpl();
    return sqlDate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlTimeStamp createSqlTimeStamp()
  {
    SqlTimeStampImpl sqlTimeStamp = new SqlTimeStampImpl();
    return sqlTimeStamp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SqlInterval createSqlInterval()
  {
    SqlIntervalImpl sqlInterval = new SqlIntervalImpl();
    return sqlInterval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public LargeObjectType createLargeObjectType()
  {
    LargeObjectTypeImpl largeObjectType = new LargeObjectTypeImpl();
    return largeObjectType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RowIdType createRowIdType()
  {
    RowIdTypeImpl rowIdType = new RowIdTypeImpl();
    return rowIdType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SortDirectionEnum createSortDirectionEnumFromString(EDataType eDataType, String initialValue)
  {
    SortDirectionEnum result = SortDirectionEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSortDirectionEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DdlDslPackage getDdlDslPackage()
  {
    return (DdlDslPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static DdlDslPackage getPackage()
  {
    return DdlDslPackage.eINSTANCE;
  }

} //DdlDslFactoryImpl
